Index: src/common/weeconfig.c
===================================================================
RCS file: /sources/weechat/weechat/src/common/weeconfig.c,v
retrieving revision 1.147
diff -u -d -p -B -r1.147 weeconfig.c
--- src/common/weeconfig.c	12 Feb 2007 17:39:35 -0000	1.147
+++ src/common/weeconfig.c	23 Mar 2007 11:17:01 -0000
@@ -2486,34 +2528,47 @@ config_write (char *config_name)
         {
             weechat_iconv_fprintf (file, "\n[server]\n");
             weechat_iconv_fprintf (file, "server_name = \"%s\"\n", ptr_server->name);
-            weechat_iconv_fprintf (file, "server_autoconnect = %s\n",
-                                   (ptr_server->autoconnect) ? "on" : "off");
-            weechat_iconv_fprintf (file, "server_autoreconnect = %s\n",
-                                   (ptr_server->autoreconnect) ? "on" : "off");
-            weechat_iconv_fprintf (file, "server_autoreconnect_delay = %d\n",
-                                   ptr_server->autoreconnect_delay);
+            if (ptr_server->isset.autoconnect)
+                weechat_iconv_fprintf (file, "server_autoconnect = %s\n",
+                                       (ptr_server->setting.autoconnect) ? "on" : "off");
+            if (ptr_server->isset.autoreconnect)
+                weechat_iconv_fprintf (file, "server_autoreconnect = %s\n",
+                                       (ptr_server->setting.autoreconnect) ? "on" : "off");
+            if (ptr_server->isset.autoreconnect_delay)
+                weechat_iconv_fprintf (file, "server_autoreconnect_delay = %d\n",
+                                       ptr_server->setting.autoreconnect_delay);
             weechat_iconv_fprintf (file, "server_address = \"%s\"\n", ptr_server->address);
             weechat_iconv_fprintf (file, "server_port = %d\n", ptr_server->port);
-            weechat_iconv_fprintf (file, "server_ipv6 = %s\n",
-                                   (ptr_server->ipv6) ? "on" : "off");
-            weechat_iconv_fprintf (file, "server_ssl = %s\n",
-                                   (ptr_server->ssl) ? "on" : "off");
+            if (ptr_server->isset.ipv6)
+                weechat_iconv_fprintf (file, "server_ipv6 = %s\n",
+                                       (ptr_server->setting.ipv6) ? "on" : "off");
+            if (ptr_server->isset.ssl)
+                weechat_iconv_fprintf (file, "server_ssl = %s\n",
+                                       (ptr_server->setting.ssl) ? "on" : "off");
             weechat_iconv_fprintf (file, "server_password = \"%s\"\n",
                                    (ptr_server->password) ? ptr_server->password : "");
-            weechat_iconv_fprintf (file, "server_nick1 = \"%s\"\n", ptr_server->nick1);
-            weechat_iconv_fprintf (file, "server_nick2 = \"%s\"\n", ptr_server->nick2);
-            weechat_iconv_fprintf (file, "server_nick3 = \"%s\"\n", ptr_server->nick3);
-            weechat_iconv_fprintf (file, "server_username = \"%s\"\n", ptr_server->username);
-            weechat_iconv_fprintf (file, "server_realname = \"%s\"\n", ptr_server->realname);
-            weechat_iconv_fprintf (file, "server_hostname = \"%s\"\n",
-                                   (ptr_server->hostname) ? ptr_server->hostname : "");
+            if (ptr_server->isset.nick1)
+                weechat_iconv_fprintf (file, "server_nick1 = \"%s\"\n", ptr_server->setting.nick1);
+            if (ptr_server->isset.nick2)
+                weechat_iconv_fprintf (file, "server_nick2 = \"%s\"\n", ptr_server->setting.nick2);
+            if (ptr_server->isset.nick3)
+                weechat_iconv_fprintf (file, "server_nick3 = \"%s\"\n", ptr_server->setting.nick3);
+            if (ptr_server->isset.username)
+                weechat_iconv_fprintf (file, "server_username = \"%s\"\n", ptr_server->setting.username);
+            if (ptr_server->isset.realname)
+                weechat_iconv_fprintf (file, "server_realname = \"%s\"\n", ptr_server->setting.realname);
+            if (ptr_server->isset.hostname)
+                weechat_iconv_fprintf (file, "server_hostname = \"%s\"\n",
+                                       (ptr_server->setting.hostname) ? ptr_server->setting.hostname : "");
             weechat_iconv_fprintf (file, "server_command = \"%s\"\n",
                                    (ptr_server->command) ? ptr_server->command : "");
-            weechat_iconv_fprintf (file, "server_command_delay = %d\n", ptr_server->command_delay);
+            if (ptr_server->isset.command_delay)
+                weechat_iconv_fprintf (file, "server_command_delay = %d\n", ptr_server->setting.command_delay);
             weechat_iconv_fprintf (file, "server_autojoin = \"%s\"\n",
                                    (ptr_server->autojoin) ? ptr_server->autojoin : "");
-            weechat_iconv_fprintf (file, "server_autorejoin = %s\n",
-                                   (ptr_server->autorejoin) ? "on" : "off");
+            if (ptr_server->isset.autorejoin)
+                weechat_iconv_fprintf (file, "server_autorejoin = %s\n",
+                                       (ptr_server->setting.autorejoin) ? "on" : "off");
             weechat_iconv_fprintf (file, "server_notify_levels = \"%s\"\n",
                                    (ptr_server->notify_levels) ? ptr_server->notify_levels : "");
         }
Index: src/common/weeconfig.h
===================================================================
RCS file: /sources/weechat/weechat/src/common/weeconfig.h,v
retrieving revision 1.78
diff -u -d -p -B -r1.78 weeconfig.h
--- src/common/weeconfig.h	5 Jan 2007 23:41:39 -0000	1.78
+++ src/common/weeconfig.h	23 Mar 2007 11:17:01 -0000
@@ -25,20 +25,21 @@
 
 #define WEECHAT_CONFIG_NAME "weechat.rc"
 
-#define CONFIG_SECTION_NONE    -1
-#define CONFIG_SECTION_LOOK    0
-#define CONFIG_SECTION_COLORS  1
-#define CONFIG_SECTION_HISTORY 2
-#define CONFIG_SECTION_LOG     3
-#define CONFIG_SECTION_IRC     4
-#define CONFIG_SECTION_DCC     5
-#define CONFIG_SECTION_PROXY   6
-#define CONFIG_SECTION_PLUGINS 7
-#define CONFIG_SECTION_KEYS    8
-#define CONFIG_SECTION_ALIAS   9
-#define CONFIG_SECTION_IGNORE  10
-#define CONFIG_SECTION_SERVER  11
-#define CONFIG_NUMBER_SECTIONS 12
+#define CONFIG_SECTION_NONE            -1
+#define CONFIG_SECTION_LOOK            0
+#define CONFIG_SECTION_COLORS          1
+#define CONFIG_SECTION_HISTORY         2
+#define CONFIG_SECTION_LOG             3
+#define CONFIG_SECTION_IRC             4
+#define CONFIG_SECTION_DCC             5
+#define CONFIG_SECTION_PROXY           6
+#define CONFIG_SECTION_PLUGINS         7
+#define CONFIG_SECTION_KEYS            8
+#define CONFIG_SECTION_ALIAS           9
+#define CONFIG_SECTION_IGNORE          10
+#define CONFIG_SECTION_SERVER          11
+#define CONFIG_SECTION_SERVER_DEFAULTS 12
+#define CONFIG_NUMBER_SECTIONS         13
 
 #define OPTION_TYPE_BOOLEAN         1   /* values: on/off                   */
 #define OPTION_TYPE_INT             2   /* values: from min to max          */
@@ -84,6 +85,7 @@ struct t_config_option
     char **array_values;
     int *ptr_int;
     char **ptr_string;
+    ssize_t offsetof_isset;
     void (*handler_change)();
 };
 
@@ -230,7 +232,6 @@ extern int cfg_dcc_convert_spaces;
 extern int cfg_dcc_auto_rename;
 extern int cfg_dcc_auto_resume;
 
-extern int cfg_proxy_use;
 extern int cfg_proxy_type;
 extern char *cfg_proxy_type_values[];
 extern int cfg_proxy_ipv6;
@@ -268,7 +269,7 @@ extern void config_option_list_get_value
 extern t_config_option *config_option_search (char *);
 extern void config_option_search_option_value (char *, t_config_option **, void **);
 extern int config_set_value (char *, char *);
-extern void *config_get_server_option_ptr (t_irc_server *, char *);
+extern void *config_get_server_option_ptr (t_irc_server *, const t_config_option *);
 extern int config_set_server_value (t_irc_server *, char *, char *);
 extern int config_read ();
 extern int config_create_default ();
Index: src/gui/curses/gui-curses-input.c
===================================================================
RCS file: /sources/weechat/weechat/src/gui/curses/gui-curses-input.c,v
retrieving revision 1.12
diff -u -d -p -B -r1.12 gui-curses-input.c
--- src/gui/curses/gui-curses-input.c	20 Mar 2007 10:18:25 -0000	1.12
+++ src/gui/curses/gui-curses-input.c	23 Mar 2007 11:17:01 -0000
@@ -357,7 +357,7 @@ gui_input_draw (t_gui_buffer *buffer, in
                         
                         if (SERVER(buffer))
                             ptr_nickname = (SERVER(buffer)->nick) ?
-                                SERVER(buffer)->nick : SERVER(buffer)->nick1;
+                                SERVER(buffer)->nick : SERVER_GET(SERVER(buffer), nick1);
                         else
                             ptr_nickname = cfg_look_no_nickname;
                         
Index: src/gui/curses/gui-curses-main.c
===================================================================
RCS file: /sources/weechat/weechat/src/gui/curses/gui-curses-main.c,v
retrieving revision 1.11
diff -u -d -p -B -r1.11 gui-curses-main.c
--- src/gui/curses/gui-curses-main.c	5 Jan 2007 23:41:39 -0000	1.11
+++ src/gui/curses/gui-curses-main.c	23 Mar 2007 11:17:01 -0000
@@ -222,7 +222,7 @@ gui_main_loop ()
             /* check if reconnection is pending */
             if ((!ptr_server->is_connected)
                 && (ptr_server->reconnect_start > 0)
-                && (new_time >= (ptr_server->reconnect_start + ptr_server->autoreconnect_delay)))
+                && (new_time >= (ptr_server->reconnect_start + SERVER_GET(ptr_server, autoreconnect_delay))))
                 server_reconnect (ptr_server);
             else
             {
Index: src/irc/irc-dcc.c
===================================================================
RCS file: /sources/weechat/weechat/src/irc/irc-dcc.c,v
retrieving revision 1.57
diff -u -d -p -B -r1.57 irc-dcc.c
--- src/irc/irc-dcc.c	5 Jan 2007 23:41:38 -0000	1.57
+++ src/irc/irc-dcc.c	23 Mar 2007 11:17:02 -0000
@@ -288,7 +288,7 @@ dcc_connect_to_sender (t_irc_dcc *ptr_dc
     char *ip4;
     int ret;
     
-    if (cfg_proxy_use)
+    if (SERVER_GET(ptr_dcc->server, proxy_use))
     {
         memset (&addr, 0, sizeof (addr));
         addr.sin_addr.s_addr = htonl (ptr_dcc->addr);
@@ -303,7 +303,7 @@ dcc_connect_to_sender (t_irc_dcc *ptr_dc
         ret = connect (ptr_dcc->sock, (struct sockaddr *) &addr, sizeof (addr));
         if ((ret == -1) && (errno != EINPROGRESS))
             return 0;
-        if (pass_proxy (ptr_dcc->sock, ip4, ptr_dcc->port, ptr_dcc->server->username) == -1)
+        if (pass_proxy (ptr_dcc->sock, ip4, ptr_dcc->port, SERVER_GET(ptr_dcc->server, username)) == -1)
             return 0;
     }
     else
Index: src/irc/irc-display.c
===================================================================
RCS file: /sources/weechat/weechat/src/irc/irc-display.c,v
retrieving revision 1.44
diff -u -d -p -B -r1.44 irc-display.c
--- src/irc/irc-display.c	16 Mar 2007 08:40:11 -0000	1.44
+++ src/irc/irc-display.c	23 Mar 2007 11:17:02 -0000
@@ -385,40 +385,52 @@ irc_display_server (t_irc_server *server
                 _("connected") : _("not connected"),
                 GUI_COLOR(COLOR_WIN_CHAT_DARK));
     
-    gui_printf (NULL, "  server_autoconnect . . . . : %s%s\n",
-                (server->autoconnect) ? _("on") : _("off"),
+    gui_printf (NULL, "  server_autoconnect . . . . : %s%s%s\n",
+                SERVER_GET(server, autoconnect) ? _("on") : _("off"),
+                server->isset.autoconnect ? "" : _(" <default>"),
                 (server->command_line) ?
                 _(" (temporary server, will not be saved)") : "");
-    gui_printf (NULL, "  server_autoreconnect . . . : %s\n",
-                (server->autoreconnect) ? _("on") : _("off"));
-    gui_printf (NULL, "  server_autoreconnect_delay : %d %s\n",
-                server->autoreconnect_delay,
-                _("seconds"));
+    gui_printf (NULL, "  server_autoreconnect . . . : %s%s\n",
+                SERVER_GET(server, autoreconnect) ? _("on") : _("off"),
+                server->isset.autoreconnect ? "" : _(" <default>")
+                );
+    gui_printf (NULL, "  server_autoreconnect_delay : %d %s%s\n",
+                SERVER_GET(server, autoreconnect_delay),
+                _("seconds"),
+                server->isset.autoreconnect_delay ? "" : _(" <default>"));
     gui_printf (NULL, "  server_address . . . . . . : %s\n",
                 server->address);
     gui_printf (NULL, "  server_port  . . . . . . . : %d\n",
                 server->port);
-    gui_printf (NULL, "  server_ipv6  . . . . . . . : %s\n",
-                (server->ipv6) ? _("on") : _("off"));
-    gui_printf (NULL, "  server_ssl . . . . . . . . : %s\n",
-                (server->ssl) ? _("on") : _("off"));
+    gui_printf (NULL, "  server_ipv6  . . . . . . . : %s%s\n",
+                SERVER_GET(server, ipv6) ? _("on") : _("off"),
+                server->isset.ipv6 ? "" : _(" <default>"));
+    gui_printf (NULL, "  server_proxy_use . . . . . : %s%s\n",
+                SERVER_GET(server, proxy_use) ? _("on") : _("off"),
+                server->isset.proxy_use ? "" : _(" <default>"));
+    gui_printf (NULL, "  server_ssl . . . . . . . . : %s%s\n",
+                SERVER_GET(server, ssl) ? _("on") : _("off"),
+                server->isset.ssl ? "" : _(" <default>"));
     gui_printf (NULL, "  server_password  . . . . . : %s\n",
                 (server->password && server->password[0]) ?
                 _("(hidden)") : "");
-    gui_printf (NULL, "  server_nick1/2/3 . . . . . : %s %s/ %s%s %s/ %s%s\n",
-                server->nick1,
+    gui_printf (NULL, "  server_nick1/2/3 . . . . . : %s%s %s/ %s%s%s %s/ %s%s%s\n",
+                SERVER_GET(server, nick1), server->isset.nick1 ? "" : _(" <default>"),
                 GUI_COLOR(COLOR_WIN_CHAT_DARK),
                 GUI_COLOR(COLOR_WIN_CHAT),
-                server->nick2,
+                SERVER_GET(server, nick2), server->isset.nick2 ? "" : _(" <default>"),
                 GUI_COLOR(COLOR_WIN_CHAT_DARK),
                 GUI_COLOR(COLOR_WIN_CHAT),
-                server->nick3);
-    gui_printf (NULL, "  server_username  . . . . . : %s\n",
-                server->username);
-    gui_printf (NULL, "  server_realname  . . . . . : %s\n",
-                server->realname);
-    gui_printf (NULL, "  server_hostname  . . . . . : %s\n",
-                (server->hostname) ? server->hostname : "");
+                SERVER_GET(server, nick3), server->isset.nick3 ? "" : _(" <default>"));
+    gui_printf (NULL, "  server_username  . . . . . : %s%s\n",
+                SERVER_GET(server, username),
+                server->isset.username ? "" : _(" <default>"));
+    gui_printf (NULL, "  server_realname  . . . . . : %s%s\n",
+                SERVER_GET(server, realname), 
+                server->isset.realname ? "" : _(" <default>"));
+    gui_printf (NULL, "  server_hostname  . . . . . : %s%s\n",
+                SERVER_GET(server, hostname),
+                server->isset.hostname ? "" : _(" <default>"));
     if (server->command && server->command[0])
         string = strdup (server->command);
     else
@@ -435,9 +447,10 @@ irc_display_server (t_irc_server *server
         gui_printf (NULL, "  server_command . . . . . . : %s\n",
                     (server->command && server->command[0]) ?
                     server->command : "");
-    gui_printf (NULL, "  server_command_delay . . . : %d %s\n",
-                server->command_delay,
-                _("seconds"));
+    gui_printf (NULL, "  server_command_delay . . . : %d %s%s\n",
+                SERVER_GET(server, command_delay),
+                _("seconds"),
+                server->isset.command_delay ? "" : _(" <default>"));
     gui_printf (NULL, "  server_autojoin  . . . . . : %s\n",
                 (server->autojoin && server->autojoin[0]) ?
                 server->autojoin : "");
Index: src/irc/irc-recv.c
===================================================================
RCS file: /sources/weechat/weechat/src/irc/irc-recv.c,v
retrieving revision 1.159
diff -u -d -p -B -r1.159 irc-recv.c
--- src/irc/irc-recv.c	22 Mar 2007 13:26:50 -0000	1.159
+++ src/irc/irc-recv.c	23 Mar 2007 11:17:03 -0000
@@ -592,7 +592,7 @@ irc_cmd_recv_kick (t_irc_server *server,
         nick_free_all (ptr_channel);
         gui_nicklist_draw (ptr_channel->buffer, 1, 1);
         gui_status_draw (ptr_channel->buffer, 1);
-        if (server->autorejoin)
+        if (SERVER_GET(server, autorejoin))
             irc_cmd_send_join (server, NULL, ptr_channel->name);
     }
     {
@@ -2423,8 +2423,8 @@ irc_cmd_recv_001 (t_irc_server *server, 
 	    free_multi_command (commands);
 	}
 	
-	if (server->command_delay > 0)
-	    sleep (server->command_delay);
+	if (SERVER_GET(server, command_delay) > 0)
+	    sleep (SERVER_GET(server, command_delay));
     }
 	
     /* auto-join after disconnection (only rejoins opened channels) */
@@ -4781,31 +4781,31 @@ irc_cmd_recv_433 (t_irc_server *server, 
     
     if (!server->is_connected)
     {
-        if (strcmp (server->nick, server->nick1) == 0)
+        if (strcmp (server->nick, SERVER_GET(server, nick1)) == 0)
         {
             irc_display_prefix (server, server->buffer, PREFIX_INFO);
             gui_printf (server->buffer,
                         _("%s: nickname \"%s\" is already in use, "
                         "trying 2nd nickname \"%s\"\n"),
-                        PACKAGE_NAME, server->nick, server->nick2);
+                        PACKAGE_NAME, server->nick, SERVER_GET(server, nick2));
             free (server->nick);
-            server->nick = strdup (server->nick2);
+            server->nick = strdup (SERVER_GET(server, nick2));
         }
         else
         {
-            if (strcmp (server->nick, server->nick2) == 0)
+            if (strcmp (server->nick, SERVER_GET(server, nick2)) == 0)
             {
                 irc_display_prefix (server, server->buffer, PREFIX_INFO);
                 gui_printf (server->buffer,
                             _("%s: nickname \"%s\" is already in use, "
                             "trying 3rd nickname \"%s\"\n"),
-                            PACKAGE_NAME, server->nick, server->nick3);
+                            PACKAGE_NAME, server->nick, SERVER_GET(server, nick3));
                 free (server->nick);
-                server->nick = strdup (server->nick3);
+                server->nick = strdup (SERVER_GET(server, nick3));
             }
             else
             {
-                if (strcmp (server->nick, server->nick3) == 0)
+                if (strcmp (server->nick, SERVER_GET(server, nick3)) == 0)
                 {
                     irc_display_prefix (server, server->buffer, PREFIX_INFO);
                     gui_printf (server->buffer,
@@ -4821,9 +4821,9 @@ irc_cmd_recv_433 (t_irc_server *server, 
                     gui_printf (server->buffer,
                                 _("%s: nickname \"%s\" is already in use, "
                                 "trying 1st nickname \"%s\"\n"),
-                                PACKAGE_NAME, server->nick, server->nick1);
+                                PACKAGE_NAME, server->nick, SERVER_GET(server, nick1));
                     free (server->nick);
-                    server->nick = strdup (server->nick1);
+                    server->nick = strdup (SERVER_GET(server, nick1));
                 }
             }
         }
Index: src/irc/irc-send.c
===================================================================
RCS file: /sources/weechat/weechat/src/irc/irc-send.c,v
retrieving revision 1.96
diff -u -d -p -B -r1.96 irc-send.c
--- src/irc/irc-send.c	16 Mar 2007 08:40:11 -0000	1.96
+++ src/irc/irc-send.c	23 Mar 2007 11:17:04 -0000
@@ -118,12 +118,12 @@ irc_login (t_irc_server *server)
                 _("%s: using hostname \"%s\"\n"),
                 PACKAGE_NAME, hostname);
     if (!server->nick)
-        server->nick = strdup (server->nick1);
+        server->nick = strdup(SERVER_GET(server, nick1));
     server_sendf (server,
                   "NICK %s\n"
                   "USER %s %s %s :%s",
-                  server->nick, server->username, hostname, "servername",
-                  server->realname);
+                  server->nick, SERVER_GET(server, username), hostname, "servername",
+                  SERVER_GET(server, realname));
     gui_input_draw (gui_current_window->buffer, 1);
 }
 
